#!/bin/sh
#
# ArcaBit Uninstaller
#
# 2008-03-13 gophi
# - Created

listfile=/usr/share/arcabit/uninstall-data
userdel=/usr/sbin/userdel
arcacompat=/usr/bin/arcacompat
rm=/bin/rm
cp=/bin/cp

die()
{
	echo "Fatal: $1"
	exit 1
}

doit()
{
	path=$1
	echo "Removing $path"

	$rm -rf "$path" || die "Cannot remove $path"
}

uninst()
{
	path=$2
	mtime_inst=$1

	[ $mtime_inst -eq 0 ] && { doit "$path" && return; }

	mtime_now=`$arcacompat mtime "$path"`
	[ $? -eq 0 ] || die "Cannot stat $path"

	[ $mtime_inst -eq $mtime_now ] && { doit "$path" && return; }

	echo "Skipping modified file $path"
}

[ -f $listfile ] || die "Invalid list file $listfile"
[ -x $userdel ] || die "Could not find executable userdel in $userdel"
[ -x $arcacompat ] || die "Could not find executable arcacompat in $arcacompat"
[ -x $rm ] || die "Could not find executable rm in $rm"
[ -x $cp ] || die "Could not find executable cp in $cp"

$cp $listfile /tmp/arcauninstall.tmp

exec < /tmp/arcauninstall.tmp

while [ . ]; do
	read mtime path || break
	uninst "$mtime" "$path"
done

$rm -f /tmp/arcauninstall.tmp
$userdel arcabit
$rm -f $arcacompat
$rm -f /usr/sbin/arcauninstall.sh

exit 0
